; Routine pour Editeur de lutin 16x24 en MODE 0 
; Debut le 24/05/2019 - Philippe Moulin MAJ Le 09/07/2019
; # SOUS ROUTINES 	> #A100 - #A1FF
; # ROUTINES RSX 	> #A200 - #xxx

; ########## DEFINITION ET INITIALISATION DES VARIABLES
SOUSROUTINES	EQU #A100
ROUTINESRSX	EQU #A200

Lutin_Larg 	EQU 6					; Largeur d'un lutin (6 octets=12 pixels)
Lutin_Haut	EQU 24					; Hauteur d'un lutin (24 pixels)

CouleurCodee 	EQU #A000 ; #A00F			; 16 Emplacements contenant les couleurs Codees
INKparDefaut	EQU #A010 ; #A01F			; 16 emplacements pour les couleurs utilisateur
CurseurLutin	EQU #A020 ; #A021			; Position du curseur pour l'affichage des lutins
Curseur4x6	EQU #A022 ; #A023			; Equivalent a un 'LOCATE' mais pour les demis caracteres		
EncrePapier	EQU #A024 ; #A029			; Enplacement des 3 encres et 3 papiers

TabFonte	EQU #A02A ; #A0DB			; Demi Caractere (De " !'......Z")= 59*3
TabMode		EQU #A0DC ; #A0E2			; Table qui remplace les XOR(HL NOP AND(HL) OR(HL) ADD(HL)
TabLutin	EQU #8000 ; #9F7F			; 56 lutin de (0 a 55)
CouleurDesINK	EQU #9F80 ; #9F8F			; 16 emplacements pour les couleurs utilisateur


ORG	CouleurCodee 
; 	 #  00  01  02  03  04  05  06  07  08  09  0A  0B  0C  0D  0E  0F	; Numero du PEN en MODE 0
 	DB #00,#40,#04,#44,#10,#50,#14,#54,#01,#41,#05,#45,#11,#51,#15,#55	; Couleur correspondante

ORG 	INKparDefaut
	DB 1, 13, 9, 10, 21, 23, 2, 8, 5, 0, 3, 6, 16, 15, 24, 26		; Encre par defaut

ORG	CouleurDesINK
	DB 1, 13, 9, 10, 21, 23, 2, 8, 5, 0, 3, 6, 16, 15, 24, 26		; Encre par defaut

ORG	CurseurLutin		
 	DB 199, 0 					; (LIGNE, COLONE) par defaut en haut a gauche
ORG	Curseur4x6
	DB 199, 0
ORG 	EncrePapier
	DB #40, #04, #44, #55, #00, #00			; Par defaut> Encre 1, 2, 3 et Papier 0, 0, 0 
ORG 	TabMode
	DB #00, #AE, #A6, #B6				; Mode d'affichage 'Normal,Xor,And,Or,Add'

; ########## SOUS ROUTINES ##########
ORG SOUSROUTINES

ADRLUTIN ; ########## CE> 'A'=Numero du lutin - CS> 'HL'=Adresse du lutin 'A'=0 'BC'=HS
	LD HL, TabLutin					; 'HL' Pointe sur le premier lutin
	CP A, 56					; Verifier si on ne va pas au dela de la table
	JR C, NumeroLutinOK				; Sinon 'A' designera le lutin 0
	XOR A						; Equivalent a LD A, 0

	NumeroLutinOK
	OR A						; Et si c'est le lutin 0 
	RET Z						; On ne calcul rien du tout
	LD BC, Lutin_Larg * Lutin_Haut			; Sinon un lutin fait 144 octets (12x24)/2 car 2 pixels par octet

	TabLutin_Add_BC
	ADD HL, BC					; Il faut multiplier le numero du lutin par 144 
	DEC A						; Mais pour y arriver, on Additionne les 144 octets 
	JR NZ, TabLutin_Add_BC				; jusqu'au numero demande
	RET 

LOCATELUTIN ; ########## CE> 'H'=Colonne 'L'=Ligne - CS> 'A'=HS 'HL'=Positions reelles
	LD A, L						; 'A' contient les lignes
	CP A, 200					; Si 'A' => 200, on est hors ecran  
	RET NC						; Alors on ne modifie pas les coordonnes
	CP A, Lutin_Haut - 1				; Idem, si 'A' <23 on sort de l'ecran
	RET C						; Et on evite le plantage
	LD L, A						; Le premier parametre Lig est correcte
	LD A, H						; On passe aux colonnes
	CP A, 159 - Lutin_Larg  - Lutin_Larg		; Si => 149 car de 148 inclus + 12 = 159 maxi  
	RET NC						; On ne valide pas les coordonnees
	LD H, A						; 'H'=Col et 'L'=Lig
	LD (CurseurLutin), HL				; On inscrit les coordonnees dans l'emplacement
	RET

AFFRECTANGLE ; ########## CE> 'H'=Colonne 'L'=Ligne 'B'=Largeur 'C'=Hauteur 'A'=CouleurCodee - CS> 'A'=HS
   PUSH DE						; Tous les registres seront conserves sauf 'A'
   PUSH HL						; Pour permettre d'accelerer la routine du ZOOM
   PUSH BC
	LD E, A						; 'A' devra contenir la couleur de Gauche et aussi de Droite
	SLA A						; Ca c'est pour le pixel de Gauche
	ADD A, E					; Et le pixel de droite
   PUSH BC						; On va appeler le vecteur qui nous fournira l'adresse d'ecran
   PUSH AF						; Mais il detruit tous les registres au passage
	LD D, 0						; On transforme les coordonnees pour les adapter
	LD E, H						; 'DE' = Colonne
	LD H, 0						; 'HL' = Ligne
	CALL #BC1D					; Vecteur systeme ('HL'=Adresse d'ecran) 
   POP AF
   POP BC						; On recupere les valeurs
	LD D, B						; Un evite un autre PUSH 
	LD E, C 
	AFFRECTANGLE_Haut
   PUSH HL						; 'HL' pointe sur l'adresse d'ecran
	LD B, D						; Et 'B' contient le nombre d'octet de largeur (1 a 80)

	AFFRECTANGLE_Larg
	ModeZoom	NOP				; Servira pour un 'ADD A, (HL)' ou 'XOR (HL)' etc etc... 
	LD (HL), A					; La couleur est injectee dans 2 pixels a la fois
	INC HL						; On passe a l'octet suivant
	DJNZ AFFRECTANGLE_Larg				; Et on fait toute la largeur
   POP HL						; 'HL' est repositionne sur la gauche
	LD BC, #800					; Il faut descendre d'une ligne
        ADD HL, BC      					
        JR NC, AFFRECTANGLE_LigneDeDessous		; Il n'y a pas de sortie de route	
        LD BC,#C000+80  				; Mais si il y a debordement hors de l'ecran 
        ADD HL, BC  					; On corrige l'adresse c'est mieux prudent

	AFFRECTANGLE_LigneDeDessous
	DEC E						; Et on fait toute la hauteur (1 a 199)
	JR NZ, AFFRECTANGLE_Haut
   POP BC
   POP HL
   POP DE
	RET

COMPARE4x6 ; ########## CE> 'A'=Code Ascii du caractere - CS> 'HL'=Adresse du demi caractere 'A'=0 'BC'=HS
	CP A, #61					; Si 'A'<"a"  On a pas besoin d'ajuster les minuscules
	JR C, COMPARE4x6_Majuscule			; Sinon on enleve le nombre de caractere entre les 
	SUB A, #20					; majuscule et les minuscules (32) pour reajuster 

	COMPARE4x6_Majuscule				; Si on est au dessus du 'Z'
	CP A, #5B					; On remplace le caractere par un " "
	JR NC, COMPARE4x6_Erreur			; En sortant par la porte ERREUR
	CP A, #20					; <" " (ESPACE) si le code ascii est <32
	JR C, COMPARE4x6_Erreur				; On fait pareil que ci-dessus
	SUB A, #20 					; Notre table de 4x6 commence a zero
	JR COMPARE4x6_OK					; Et on termine les testes

	COMPARE4x6_Erreur
	LD A,0						; Code erreur remplace la valeur par un " "

	COMPARE4x6_OK 
	LD HL, TabFonte					; 'HL' Pointe sur le debut de la table 6x6
	OR A						; Si 'A'=0, alors 'HL' est deja ajuste
   	RET Z
	LD BC, 3					; Sinon..., il on ajoute 3 octets par caractere

	COMPARE4x6_TableSuivant
	ADD HL, BC					; On continu tant que 'A' > 0 
	DEC A						; 				
   	JR NZ, COMPARE4x6_TableSuivant
	RET

PRINT4x6 ; ########## CE>'DE'= Adresse du caractere 'H'=Colonne 'L'=Ligne CS> Tous les registres sont HS
   PUSH DE
	LD D, 0						; On transforme les coordonnees pour les adapter
	LD E, H						; 'DE' = Colonne
	LD H, 0						; 'HL' = Ligne
	CALL #BC1D					; Vecteur systeme ('HL'=Adresse d'ecran) 
   POP DE
	LD B, 3						; 3 Octets par caractere

	PRINT4x6_Hauteur
   PUSH BC			
   PUSH DE
	LD A, (DE)					; 'A' contient l' octet de 8 bits a traiter
	LD C, A						; Parce-que 'LD C, (DE)' n'est pas possible
	LD B, 2						; Chaque octet est compose de deux lignes

	PRINT4x6_4BitsX2
	LD E, 2						; Chaque ligne est composee de (2 octets sur l'ecran)

	PRINT4x6_Largeur				; 'A' pour le pixel droit - 'D' pour le pixel gauche
	LD A, (IY + 0)					; On injecte la couleur de l'encre de droite dans 'A'
	LD D, A						; Et aussi dans 'D' pour celle de gauche
	SLA C						; On fait tourner les Bits de chacun des 3 octets du caractere
	JR C, PRINT4x6_PixelG				; Si le Bit vaut 1, on garde la couleur de l'encre dans 'D' 
	LD D, (IY + 3)					; Sinon on injecte la couleur du papier dans 'D'

	PRINT4x6_PixelG
	SLA C						; Pour le pixel de droite on fait pareil que 'D' mais avec 'A'
	JR C, PRINT4x6_PixelD				; Si le Bit vaut 0
	LD A, (IY + 3)					; On remplace la couleur de l'encre par le couleur du papier

	PRINT4x6_PixelD					; 'D' Concerne le pixel de gauche et 'A' le pixel de droite
	SLA D						; On ajuste la couleur (Pour la gauche seulement)
	ADD A, D					; Puis on additionne les deux couleurs pour obtenir un octet
	ModePrint4x6	NOP 				; Il est possible d'ajouter un effet sur l'octet
							; OR(HL) - AND(HL) - XOR(HL) - ADD(HL)  - NOP - Etc Etc
	LD (HL), A					; On affiche l'octet sur l'ecran 
	INC HL						; Et on s'occupe du deuxieme octet du caractere
	DEC E
	JR NZ, PRINT4x6_Largeur	
	LD DE, #800-2					; Il faut descendre d'une ligne de l'ecran 
        ADD HL, DE      				; La formule est (HL=HL+#800-Largeur du caractere) 	
        JR NC, PRINT4x6_LigneDeDessous			; Mais il faut reajuster si on sort de l'ecran
        LD DE,#C000+80  				; Pour ne pas ecraser les donnees et ne pas planter
        ADD HL, DE  					; l'Amstrad CPC 6128 

	PRINT4x6_LigneDeDessous
	DJNZ, PRINT4x6_4BitsX2				; A chaque octet du caractere (2 Lignes sur l'ecran) 
	INC IY						; On passe a la couleur suivante 
   POP DE
	INC DE						; Et on fait pointer 'DE' sur l'octet suivant
   POP BC
	DJNZ, PRINT4x6_Hauteur				; Jusqu'a afficher le caractere dans sa totalite
	RET

LOCATE4x6 ; ########## CE> 'D'=Colonne(1 a 40) 'E'=Ligne(1 a 33) - CS> 'DE'=HS 'A'=HS 
	DEC E						; On enleve 1 ligne de hauteur pour les origines partants de 0
	LD A, E						; Il faut multiplier la valeur par 6
	SLA A						; 'A' * 2
	ADD A, E					; 'A' + 'E' * 3
	SLA A						; 'A' * 6
	LD E, A						; Les origines des lignes en haut de l'ecran commencent a 199
	LD A, 199					; Donc on inverse la position
	SUB A, E					; Et 'A' contient la bonne hauteur
	CP A, 5						; Mais si le parametres des lignes n'est pas respecte
	RET C						; Si 'E'>33
;	CP A, 200					; Si 'E'<1
;	RET NC						; On sera hors ecran, donc on sort
	LD E, A						; Sinon 'E' contient les lignes
	DEC D						; Les colonnes commencent a 0, a gauche de l'ecran
	LD A, D						; Il faut multiplier la valeur par 4
	SLA A						; 'A' * 2 
	SLA A						; 'A' * 4
	CP A, 158					; Si 'D'<1 ou 'D'>40 
	RET NC						; On sort
	LD D, A
	LD (Curseur4x6), DE				; Les coordonnees sont inscritent en lieu sur
	RET

ENCRE4x6 ; ########## CE> 'A'=Nombre de parametre 'IX'=Parametre - CS>'A' 'HL' 'DE' 'BC' 'IX' sont Modifies
	LD HL, EncrePapier - 1			; 'HL' est positionne sur l' emplacement des encres - 1
	JR ENCRE4x6_EncreOuPapier		; On saute pour la suite du programme

PAPIER4x6  ; ########## CE> 'A'=Nombre de parametre CS>'A' 'HL' 'DE' 'BC' sont HS
	LD HL, EncrePapier + 2			; 'HL' pointe sur l'emplacement des papiers - 1

	ENCRE4x6_EncreOuPapier 			; A ce stade, 'HL' pointe soit sur les encres soit sur les papiers
	LD B, 0					; On va ajouter a 'HL' le nombre de parametres
	LD C, A					; 'BC' = nombre de parametre
	ADD HL, BC				; 'HL' pointe sur la derniere couleur a traiter
	LD B, A					; 'B' contient le nombres de parametre

	ENCRE4x6_NbParametre
	LD A, (IX + 0)				; 'A' = valeur du parametre 
	CP 16					; Si >= 16, il n'y a que 16 couleurs en MODE 0 
	RET NC					; On ne reste pas, Faut pas pousser non plus
	LD DE, CouleurCodee			; 'DE' pointe sur la table des couleurs codees
	ADD A, E				; 'A' Contient le numero de la couleur demandee
	LD E, A					; 'DE' Pointe sur la correspondance de la couleur demandee 
	LD A, (DE)				; 'A' est charge avec le code de la couleur codee de MODE 0
	LD (HL), A				; On l'incrit simplement dans 'HL'
	DEC HL					; Et on passe a la couleur suivant
	INC IX
	INC IX					; Et aussi au parametre suivant
	DJNZ ENCRE4x6_NbParametre		; On recommence tant qu'il y a des parametres
	RET


; ########## ROUTINES RSX ##########
ORG ROUTINESRSX

RSXLUTIN ; ########## APPEL> CALL xxxx, Numero[, Col, Lig]
	CP A, 1						; Si il n'y a que 1 parametre
	JR Z, RSXLUTIN_Direct				; On saute la partie de positionnement des lutins
	CP A, 3						; Mais plus de 3 parametres
	RET NZ						; Provoque un retour au basic
	LD H, (IX + 2)					; On initialise les parametres 'H'=Colonne
	LD L, E						; 'L'=Ligne
	CALL LOCATELUTIN				; Et on appele la routine de posionnement des Lutins
	LD E, (IX + 4)					; On place le numero du lutin dans 'E'

	RSXLUTIN_Direct
	LD A, E						; 'A' = Le numero du Lutin qui doit etre affiche
	CALL ADRLUTIN					; En sortie, 'HL' contiendra l'adresse du lutin
   PUSH HL						; On utilisera un Vecteur pour positionner le premier octet
	LD HL, (CurseurLutin)				; 'H'= Col 'L'=Lig
	LD D, 0						; On transforme les coordonnees pour les adapter au Vecteur
	LD E, H						; 'DE' = Colonne
	LD H, 0						; 'HL' = Ligne
	CALL #BC1D					; Ce Vecteur transforme les coordonnees en un adresse ecran 
   POP DE						; HL=AdrEcran DE=AdrLutin
	LD B, Lutin_Haut				; La routine d'affichage demarre ici. 24 LIGNES

	RSXLUTIN_Ligne
   PUSH BC
	LD B, Lutin_Larg				; 6 OCTETS (12 PIXELS) En MODE 0
	
	RSXLUTIN_Colonne
	LD A, (DE)					; 'DE'=AdrLutin
	ModeLutin	NOP				; Emplacement pour fusionner 'A' avec (HL)
	LD (HL), A				 	; OR (HL)=#B6 -- AND (HL)=#A6 -- XOR (HL)=#AE -- NOP=#00
	INC HL 
	INC DE
	DJNZ, RSXLUTIN_Colonne				; On affiche une rangee complete du Lutin
	LD BC, #800 - Lutin_Larg			; 'HL' doit se positionner une ligne en dessous 
        ADD HL, BC   	
        JR NC, RSXLUTIN_LigneDeDessous			
        LD BC,#C000+80  				; Mais si il y a debordement hors ecran donc plantage
        ADD HL, BC  					; On corrige l'adresse

	RSXLUTIN_LigneDeDessous
   POP BC
	DJNZ, RSXLUTIN_Ligne				; Finir les 24 lignes
	RET						; Et terminer	 

RSXZOOMLUTIN ; ########## APPEL> CALL xxxx, Numero [,Col , Lig], Largeur, Hauteur
	CP A, 3
	JR Z, RSXZOOMLUTIN_Direct
	CP A, 5
	RET NZ
	LD H, (IX + 6)					; On initialise les parametres 'H'=Colonne
	LD L, (IX + 4)					; 'L'=Ligne
	CALL LOCATELUTIN				; Et on appele la routine de positionnement des Lutins
	LD A, (IX + 8)					; Comme il s'agit de parametre optionnel
	LD (IX + 4), A					; Ils faut ajuster la valeur du numero du lutin  

	RSXZOOMLUTIN_Direct
	LD A, (IX + 4)					; On place le numero du lutin dans 'A'
	CALL ADRLUTIN 					; Et on appele la routine pour faire pointer 'HL' sur le lutin
	LD DE, (CurseurLutin)				; 'D'=Colonne 'E'=Ligne
	EX HL, DE 					; 'H'=Colonne 'L'=Ligne 'DE'=Adresse du lutin
	LD C, (IX + 0)					; 'C' contient la hauteur
	LD A, C
	OR A						; Si la hauteur=0, on tombe dans une boucle infinie
	RET Z						; Alors pas de risque, on sort
	LD A, (IX + 2)					; Et pareil pour la largeur
	OR A						; Pas de boucle infini sans plantage
	RET Z						; Retour au BASIC sans afficher quoi que ce soit
	LD B, Lutin_Haut				; 'B'=Hauteur du lutin (24)

	RSXZOOMLUTIN_Hauteur
   PUSH BC						; 'C'=Largeur du zoom et 'B'=Hauteur du Lutin
   PUSH HL						; 'HL'= Adresse sur l'ecran
	LD B, Lutin_Larg				; 'B'=Largeur du lutin (6) octets soit 12 pixels

	RSXZOOMLUTIN_Largeur
  PUSH BC
	LD B, (IX + 2)					; 'B'=Largeur du zoom  
	LD A, (DE)					; 'A'=pixel gauche et pixel droit du lutin
	AND #AA						; On separe le pixel de gauche
	SRL A						; Pour lui rendre la CouleurCodee normale
	CALL AFFRECTANGLE 				; On affiche le rectangle de Gauche
	LD A, H						; Il faut se deplacer d'un rectangle
	ADD A, B					; Soit 2 * le Zoom
	ADD A, B					; (Adresse Ecran + largeur du zoom + largeur du zoom)
	LD H, A
	LD A, (DE)					; On separe le pixel de droite
	AND #55						; Et on afficle le rectangle de droite
	CALL AFFRECTANGLE 				; On affiche le rectangle de Droite	
	LD A, H						; On recommence le calcul pour l'octet suivant
	ADD A, B					; Si on rajoute 2 * le zoom en horisontal c'est
	ADD A, B					; Que le vecteur se base sur des coordonnees de 160 en MODE 0
	LD H, A						; Mais on a que 80 octets dans chaque ligne de l'ecran
	INC DE
   POP BC
	DJNZ , RSXZOOMLUTIN_Largeur			; On affiche la ligne complete du lutin
   POP HL						; Et on replache 'HL' en debut de ligne
	LD A, L						; Pour afficher la ligne suivante
	SUB A, C
	LD L, A
   POP BC
	DJNZ, RSXZOOMLUTIN_Hauteur			; On repete l'opperation pour la hauteur du lutin
	RET

RSXPRINT4x6 ; ########## APPEL> Call xxxx, Chaine$ [,Axe X, Axe Y] (X de 0 a 157) ? (Y de 5 a 199)
	CP 1
	JR Z, RSXPRINT4x6_Direct
	CP 3
	RET NZ
	LD A, E
	CP A, 200
	RET NC
	CP A, 5
	RET C
	LD L, A
	LD A, (IX + 2)
	CP A, 158
	RET NC
	LD H, A
	LD (Curseur4x6), HL
	LD BC, 4
	ADD IX, BC

	RSXPRINT4x6_Direct
	LD H, (IX + 1)					; On va recuperer l'adresse de la chaine a$
	LD L, (IX + 0)					; 'HL' Pointe sur l'adresse
	LD A, (HL)					; Le premier octet indique combien il y a de caractere
	OR A						; Si la chaine est vide... Retour vers le Basic
	RET Z
	INC HL						; Le deuxieme et troisieme octet contiennent l'emplacement 
	LD E, (HL)					; Que l'on va transferer dans 'DE'
	INC HL
	LD D, (HL)					; DE Pointe sur le 1er Caractere de la chaine... OUF
	LD B, A						; Et B = Longeur de la chaine

	RSXPRINT4x6_TouteLaChaine
   PUSH BC						; 'B'= Nombre de caractere
   PUSH DE						; 'DE' Pointe sur le caractere
	LD A, (DE)					; 'A' Contient le caractere
	CALL COMPARE4x6					; 'HL' Contient l'adresse de la table du caractere
	EX HL, DE					; 'DE'='HL'
	LD HL, (Curseur4x6)				; 'HL' Contient l'emplacement du curseur
	LD IY, EncrePapier				; 'IY' pointe sur les (encres/papiers)
   PUSH HL
	CALL PRINT4x6					; On affiche le caractere
   POP HL						; Il faut modifier le positionnement du curseur
 	LD A, H						; pour le prochain caractere
	CP A, 153					; 'H'=Colonne avant affichage, donc ajuster la valeur
	JR C, RSXPRINT4x6_ColPlusUn			; De comparaison - 2 caracteres 
	LD A, L 					; 'L'=Ligne avant affichage
	CP A, 11					; Ou la ligne si fin de colonne
	JR NC, RSXPRINT4x6_LigPlusUn
	LD H,0						; Il faut remettre les axes dans leurs origines (0, 199)
	LD L, 199					; En haut a gauche de l'ecran, pour eviter de planter !
	JR RSXPRINT4x6_Col_Lig_OK				

	RSXPRINT4x6_LigPlusUn				; Descendre d'une ligne de caractere
	LD H, 6						; il faut deduire 6 des lignes
	SUB A, H
	LD L, A						; 'L'=Ligne
	LD H, 0						; Et repartir de la gauche 'H'=0
	JR RSXPRINT4x6_Col_Lig_OK

	RSXPRINT4x6_ColPlusUn
	INC H						; Il faut se deplacer d'une colonne
	INC H						; LD A, 4; ADD A, H; LD H, A
	INC H
	INC H						; Il y a peut-etre plus simple ?

	RSXPRINT4x6_Col_Lig_OK
	LD (Curseur4x6), HL				; On sauvegarde les nouvelles coordonnees
   POP DE						; Puis on passe au caractere suivant
   POP BC						; Jusqu'au dernier 
	INC DE
	DJNZ, RSXPRINT4x6_TouteLaChaine
	RET

RSXRECTANGLE ; ########## APPEL> CALL xxxx, Colonne, Ligne, Largeur, Hauteur, Couleur normale
	CP A, 5
	RET NZ
	LD A, (IX + 4)
	OR A
	RET Z
	LD B, A
	LD A, (IX + 2)
	OR A
	RET Z
	LD C, A
	LD A ,(IX + 6)
	CP A, 200
	RET NC
	LD L, A
	LD A, (IX + 8)
	CP A, 158
	RET NC
	LD H, A
	LD A, E						; A = dernier parametre (Couleur)
	CP A, 16
	RET NC
	LD DE, CouleurCodee				; Sachant que 'DE' pointe sur une adresse de debut
	ADD A, E					; On n'est pas oblige d'additionner car 'E'=0
	LD E, A						; J'ai garde tel quel, en cas de relocation des variables
	LD A, (DE)					
	CALL AFFRECTANGLE	
	RET 

RSXSYMBOLIQUE ; ########## APPEL> Call xxxx, Colonne, Ligne, OctetN1 ... OctetN8 ... OctetNxx
	CP A, 3 					; 'A'>2 Car il faut 1 ligne au minimum 
	RET C
	SUB A, 3					; On va remonter les parametres que 'IX' pointes
	LD C, A						; Vers le parametre 'OctetN1'
	SLA C						; 'IX' contient deux octets pour chaque parametre
	LD B, 0						; 'BC'=(Nombre de parametre - 3) * 2
	ADD IX, BC					; 'IX' pointe sur le parametre 'OctetN1'
	INC A						; A contient le nombre de parametre - 2 (Col, Lig)
	LD E, A						; On Le sauvegarde pour l'utiliser en boucle
   PUSH DE
	LD A, (IX + 2)					; 'A'=Ligne
	CP A, 200
	RET NC
	LD L, A						; 'L'=Ligne 
	LD A, (IX + 4)					; 'A'=Colonne
	CP A, 153					; Si on est hors ecran
	RET NC						; On ne prend pas le risque, on retourne au Basic
	LD E, A						; 'E'=Colonne
	LD D, 0						; On transforme les coordonnees pour les adapter
	LD H, 0						; 'HL' = Ligne
	CALL #BC1D					; Vecteur systeme ('HL'=Adresse d'ecran) 
	LD IY, EncrePapier
   POP DE			 			; HL=positionEcran IY=EncrePapier IX=OctetN1 E=NbParametre

	RSXSYMBOLIQUE_NbParametre
	LD C, (IX + 0)					; 'C' contient l'octet a decoudre
	LD B, 4 					; Chaque octets seront decomposes sur 4 pixels de l'ecran

	RSXSYMBOLIQUE_4Bits
	EncreSymbolique		LD A, #40		; 'A' Contient l' Encre
	LD D, A						; 'D' Aussi pour le pixel de gauche
	SLA C						; On fait basculer 'C' vers la gauche
	JR C, RSXSYMBOLIQUE_EncreGauche			; Et si le bit est a 1, On garde l'encre gauche dans 'D'
	PapierSymbolique1	LD D, #00		; Sinon on charge 'D' avec le papier

	RSXSYMBOLIQUE_EncreGauche
	SLA C						; On fait basculer 'C' pour le pixel de droite
	JR C, RSXSYMBOLIQUE_EncreDroite			; Et si le BIT est a 1, On garde l'encre droite dans 'A'
	PapierSymbolique2		LD A, #00	; Sinon 'A' prendra le papier

	RSXSYMBOLIQUE_EncreDroite
	SLA D						; Pour le pixel de gauche, il faut multiplier par deux sa valeur
	ADD A, D					; 'A'= Le pixel de gauche et le pixel de droite
	ModeSymbolique		NOP			; On peut ajouter un effet 'XOR (HL)' ou autre
	LD (HL), A					; Et on affiche les deux pixels
	INC HL						; On passe a l'octet sur la droite 
	DJNZ, RSXSYMBOLIQUE_4Bits			; Jusqu'a allumer toute une ligne de caractere
	DEC IX						; On passe au parametre suivant sur la droite
	DEC IX						
	LD BC, #800-4					; Il faut aussi descendre d'une ligne de l'ecran 
        ADD HL, BC      				; La formule est (HL=HL+#800-Largeur du caractere) 	
        JR NC, RSXSYMBOLIQUE_LigneDeDessous		; Mais il faut reajuster si on sort de l'ecran
        LD BC,#C000+80  				; Pour ne pas ecraser les donnees et ne pas planter
        ADD HL, BC  					; l'Amstrad CPC 6128 de mon enfance... SNIF

	RSXSYMBOLIQUE_LigneDeDessous
	DEC E						; 'E' contient le nombre de parametre
	JR NZ, RSXSYMBOLIQUE_NbParametre		; Donc on fait autant de ligne qu'il y a de parametre
	RET  

RSXPENSYMBOLIQUE ; ########## APPEL Call xxxx, Encre, Papier
	CP A, 2
	RET NZ
	LD A, E
	CP A, 16
	RET NC
	LD HL, CouleurCodee
   PUSH HL
	ADD A, L
	LD L, A
	LD A, (HL)
   POP HL
	LD (PapierSymbolique1 + 1), A
	LD (PapierSymbolique2 + 1), A
	LD A, (IX + 2)
	CP A, 16
	RET NC
	ADD A, L
	LD L, A
	LD A, (HL)
	LD (EncreSymbolique + 1), A
	RET

RSXMODE ; ########## APPEL> Call xxxx, Effet		; Fixe un mode pour 'demicara,zoom,symbol......'
	CP A, 1
	RET NZ
	LD A, E
	LD HL, TabMode
	ADD A, L
	LD L, A
	LD A, (HL)
	LD (ModePrint4X6), A
	LD (ModeZoom), A
	LD (ModeLutin), A
	LD (ModeSymbolique), A
	RET

RSXENCRE4x6 ; ########## APPEL > Call xxxx, EncreN1 [, EncreN2] [, EncreN3]
	CP A, 4
	RET NC 
	CALL ENCRE4x6
	RET

RSXPAPIER4x6 ; ########## APPEL > Call xxxx, PapierN1 [, PapierN2] [, PapierN3]
	CP A, 4
	RET NC 
	CALL PAPIER4x6
	RET

RSXLOCATE4x6 ; ########## APPEL > Call xxxx, Colonne, Ligne
	CP A, 2
	RET NZ 
	LD D, (IX + 2)
	CALL LOCATE4x6
	RET

RSXLOCATELUTIN ; ########## APPEL > Call xxxx, Colonne, Ligne
	CP A, 2
	RET NZ 
	LD L, D
	LD H, (IX + 2)
	CALL LOCATELUTIN
	RET

RSXLUTINGD ; ########## APPEL, Call xxxx, Lutin
	CP A, 1
	RET NZ
	LD A, E
	CALL ADRLUTIN 					; 'HL'=Adresse du lutin
   PUSH HL
	LD B, 144					; On va inverser toutes les couleurs gauches et droites

	RSXLUTINGD_InverserLesCouleurs
	LD A, (HL)					; 'A'=Couleur Gauche et Droite
	LD D, A
	AND #AA						; 'A'=Couleur Gauche
	SRL A						; 'A' contient la couleur decodee de gauche
	LD E, A						; Qui passera a droite
	LD A, D						; 'A'=Couleur Gauche et Droite
	AND #55						; 'A' Contient la couleur de droite
	SLA A						; 'A' Contient la valeur codee de droite	
	ADD A, E					; 'A'=Couleur Gauche et Droite inversee
	LD (HL), A					; On l'inscrit pour la suite
	INC HL
	DJNZ, RSXLUTINGD_InverserLesCouleurs		; Faire tous les octets du lutin
   POP HL						; 'HL'=Adresse du lutin
	LD C, 24					; Il faut faire pivoter le lutin de 24 lignes

	RSXLUTINGD_Ligne
	INC HL						; On partira du centre du lutin pour eviter des calculs
	INC HL
   PUSH HL						; 'HL'=Centre (AdrLutin+2)
   POP DE 						
	INC DE						; 'DE'=Centre+1 (AdrLutin+3)
	LD B, 3 					; Il faut echanger 3 octets par ligne

	RSXLUTINGD_Colonne
   PUSH BC
	LD A, (DE)					; 'A'= l'octet de droite
	LDI						; L'octet de droite='(HL)'
	DEC HL						; On repositionne 'HL' car 'LDI' lui ajoute 1
	LD (HL), A					; L'octet de gauche='(DE)'
	DEC HL						; On va du centre vers la gauche
   POP BC
	DJNZ, RSXLUTINGD_Colonne			; Et on fait tous les octets de la ligne
	EX HL, DE					; 'DE' pointe deja sur la ligne en dessous
	DEC C
	JR NZ, RSXLUTINGD_Ligne				; C'est fini
	RET

RSXLUTINHB ; APPEL > Call xxxx, Lutin
	CP A, 1
	RET NZ
	LD A, E						; 'A' Contient le numero du lutin
	CALL ADRLUTIN 					; 'HL'=Adresse du lutin
   PUSH HL
	LD DE, 138					; 'DE' pointera sur la premiere ligne du lutin					
	ADD HL, DE					; 'HL' poitera sur la derniere ligne
   POP DE
	LD B, 12					; On va echanger 12 lignes

	RSXLUTINHB_Ligne
   PUSH BC
	LD B, 6						; Lignes de 6 Octets (12 pixels)

	RSXLUTINHB_Colonne
	LD A, (DE)
	LD C, (HL)
	LD (HL), A
	LD A, C
	LD (DE), A
	INC HL
	INC DE
	DJNZ, RSXLUTINHB_Colonne
	LD BC, 12					; 'DE' pointe sur la ligne suivante, mais 'HL' est
	SBC HL, BC					; chez le voisin. On le reequilibre sur la ligne de dessus
   POP BC
	DJNZ, RSXLUTINHB_Ligne
	RET

RSXLUTINHAUT ; APPEL > Call xxxx, Lutin
	CP A, 1
	RET NZ
	LD A, E						; 'A' Contient le numero du lutin
	CALL ADRLUTIN 					; 'HL'=Adresse du lutin
   PUSH HL
	LD DE, 06 
	ADD HL, DE
   POP DE
	LD B, 138

	RSXLUTINHAUT_ColonneEtLigne
	LD A,(DE)
	LDI
	DEC HL
	LD (HL), A
	INC HL
	DJNZ, RSXLUTINHAUT_ColonneEtLigne
	RET

RSXLUTINBAS ; APPEL > Call xxxx, Lutin
	CP A, 1
	RET NZ
	LD A, E						; 'A' Contient le numero du lutin
	INC A						; On va travailler en partant de la fin du lutin
	CALL ADRLUTIN 					; 'HL'=Adresse du lutin + (1 Lutin)
	DEC HL						; 'HL'=Adresse Lutin + (143 octets)
   PUSH HL
	LD DE, 06 
	SBC HL, DE					; 'DE' pointe en fin de lutin
   POP DE						; 'HL' est juste sur la ligne de dessus
	LD B, 138

	RSXLUTINBAS_ColonneEtLigne
	LD A,(DE)
	LDD						; C'est rapide et evite du codage '(DE)=(HL)' 'DEC HL, DE' 'DEC BC'
	INC HL
	LD (HL), A
	DEC HL
	DJNZ, RSXLUTINBAS_ColonneEtLigne
	RET

RSXLUTINGAUCHE ; APPEL > Call xxxx, Lutin
	CP A, 1
	RET NZ
	LD A, E						; 'A' Contient le numero du lutin
	CALL ADRLUTIN 					; 'HL'=Adresse du lutin + (1 Lutin)
	LD C, 24					; Il faut decoder les 24 lignes du lutin

	RSXLUTINGAUCHE_Ligne
	LD A, (HL)					; On va placer dans 'D' la couleur tout a gauche
	AND #AA
	SRL A
	LD D, A						; 'D'=Couleur de gauche qui ira tout a droite
	LD B, 5						; Il faut travailler sur 2 octets a la fois

	RSXLUTINGAUCHE_Colonne
	LD A, (HL)					; 'E' Devra contenir la couleur de droite
	AND #55
	SLA A						; Qui ira sur la gauche 
	LD E, A
	INC HL						; Il faut recuperer la couleur de droite de l'octet suivant 
	LD A, (HL) 
	AND #AA
	SRL A						; Qui passera a gauche
	ADD A, E					; On a les deux couleur
	DEC HL
	LD (HL), A					; Que l'on inscrit dans 'HL'
	INC HL						; On passe les 5 premiers octets
	DJNZ, RSXLUTINGAUCHE_Colonne
	LD A, (HL)					; Pour le dernier octet
	AND #55						; Il faut passer la couleur de droite sur la gauche
	SLA A
	ADD A, D					; Et recuperer la couleur qui etait toute a gauche
	LD (HL), A
	INC HL						; On passe a la ligne suivante
	DEC C
	JR NZ, RSXLUTINGAUCHE_Ligne
	RET


RSXLUTINDROITE ; APPEL > Call xxxx, Lutin
	CP A, 1
	RET NZ
	LD A, E						; 'A' Contient le numero du lutin
	CALL ADRLUTIN 					; 'HL'=Adresse du lutin
	LD C, 24					; Il faut decoder les 24 lignes du lutin

	RSXLUTINDROITE_Ligne
   PUSH HL
	LD DE, 5
	ADD HL, DE					; 'DE' Pointe sur le dernier octet de la ligne
	LD A, (HL)					; On va placer dans 'D' la couleur tout a droite
   POP HL
	AND #55
	SLA A
	LD D, A						; 'D'=Couleur de droite qui ira tout a gauche
	LD B, 6						; Il faut travailler sur 2 octets a la fois

	RSXLUTINDROITE_Colonne
	LD A, (HL)					; 'E' servira a sauvegarder la couleur de droite
	AND #55
	SLA A						; Qui ira sur la gauche 
	LD E, A
	LD A, (HL) 
	AND #AA
	SRL A						; Qui passera a gauche
	ADD A, D					; On a les deux couleur
	LD (HL), A					; Que l'on inscrit dans 'HL'
	INC HL	
	LD D, E						; On passe les 5 premiers octets
	DJNZ, RSXLUTINDROITE_Colonne
	DEC C
	JR NZ, RSXLUTINDROITE_Ligne
	RET

RSXLUTINSCR ; ########## APPEL> CALL xxxx, Numero, Col, Lig
	CP A, 3
	RET NZ
	LD A, (IX + 4)
	CALL ADRLUTIN
   PUSH HL
	LD L, E
	LD H, (IX + 2)
	CALL LOCATELUTIN				; Et on appele la routine de posionnement des Lutins						; On utilisera un Vecteur pour positionner le premier octet
	LD D, 0						; On transforme les coordonnees pour les adapter au Vecteur
	LD E, H						; 'DE' = Colonne
	LD H, 0						; 'HL' = Ligne
	CALL #BC1D					; Ce Vecteur transforme les coordonnees en un adresse ecran 
   POP DE						; HL=AdrEcran DE=AdrLutin
	LD B, Lutin_Haut				; 24 LIGNES a transferer

	RSXLUTINSCR_Ligne
   PUSH BC
	LD BC, Lutin_Larg				; 6 OCTETS (12 PIXELS) En MODE 0
	LDIR						; Tranfert de l'ecran plus rapide 
	LD BC, #800 - Lutin_Larg			; 'HL' doit se positionner une ligne en dessous 
        ADD HL, BC   	
        JR NC, RSXLUTINSCR_LigneDeDessous			
        LD BC,#C000+80  				; Mais si il y a debordement hors ecran donc plantage
        ADD HL, BC  					; On corrige l'adresse

	RSXLUTINSCR_LigneDeDessous
   POP BC
	DJNZ, RSXLUTINSCR_Ligne				; Finir les 24 lignes
	RET	

RSXTRANSFERT ; ########## APPEL> CALL xxxx, Nb d'octet, Source, Destination
	CP A, 3
	RET NZ
	LD H, (IX + 3)					; 'DE' Contient deja la destination
	LD L, (IX + 2)					; 'HL' Contient la source
	LD B, (IX + 5)
	LD C, (IX + 4)					; 'BC' le nombre d'octet
	LDIR						; Et le trasfert est fini
	RET

	NOP
	NOP
RSXRECT ; ########## APPEL > CALL xxxx, Col, Lig, Col1, Lig1, Couleur 
; Trace un rectangle vide du point (Col, Lig) au point (Col1, Lig1) Coordonnees absolues
	CP 5
	RET NZ
	LD A, E
	CP 16						; 16 Couleurs MODE 0
	RET NC
	CALL &BBDE 					; VECTEUR PEN
	LD H, (IX + 7)
	LD L, (IX + 6)
	LD D, (IX + 9)
	LD E, (IX + 8)
   PUSH DE
   PUSH HL
   PUSH HL
   PUSH DE
	CALL #BBC0 					; VECTEUR MOVE
	LD H, (IX + 3)
	LD L, (IX + 2)
    POP DE
    PUSH HL	
	CALL #BBF6					; VECTEUR DRAW
	LD D, (IX + 5)
	LD E, (IX + 4)
   POP HL
   PUSH DE
	CALL #BBF6
   POP DE
   POP HL
	CALL #BBF6
   POP HL
   POP DE
	CALL #BBF6
	RET
	NOP
	NOP
RSXFILLLIMITE ; ########## FILLLIMITE, ColGauche, ColDroite, LigHaut, LigBas
; Place les limites pour le remplissage FILL (de 0 a 639) et (de 399 a 0)
	CP 4
	RET NZ
	LD (FILL_LIMITE_BAS + 1), DE		; Limite ligne bas
	LD H, (IX + 3)
	LD L, (IX + 2)
	LD (FILL_LIMITE_HAUT + 1), HL		; Limite ligne haut
	LD H, (IX + 5)
	LD L, (IX + 4)
	LD (FILL_LIMITE_DROITE + 1), HL		; Limite colonne droite
	LD H, (IX + 7)
	LD L, (IX + 6)
	LD (FILL_LIMITE_GAUCHE + 1), HL		; Limite colonne gauche
	RET

; ########## Sous routine move et draw
FILL_Remplir ; Trace une ligne defini par FILL
	FILL_Lig 	LD HL, 0000 ; Lig
	FILL_ColGauche 	LD DE, 0000 ; Col gauche
   PUSH HL
	CALL #BBC0
   POP HL
	FILL_ColDroite 	LD DE, 0000 ; Col droite
	CALL #BBF6
	RET

RSXFILL ; ########## RSXFILL, Col, Lig, Couleur
	CP 3
	RET NZ
	LD A, E
	CP 16
	RET NC
	CALL &BBDE 					; VECTEUR PEN
	LD HL, 0000
	LD (FILL_TEST_HAUT + 1), HL
	LD A, L
	LD (FILL_TEST_HAUT), A				; 3 * NOP pour le saut
	LD H, (IX + 3)
	LD L, (IX + 2)
	LD D, (IX + 5)
	LD E, (IX + 4)
   	PUSH HL						; Lire la couleur a remplacer
   	PUSH DE
   	CALL #BBF0
	LD (Fill_CoulDroit + 1), A			; Et l'inscrire pour les comparaisons
	LD (Fill_CoulGauche + 1), A
	LD (Fill_CoulHaut + 1), A
	LD (Fill_CoulBas + 1), A
   	POP DE
   	POP HL
; -------------------------------- FIN D'INITIALISATION ET DEBUT DES TESTS
  	PUSH HL
  	PUSH DE

FILL_DIR_HAUT
	LD (FILL_Lig + 1), HL
 	PUSH HL
   	PUSH DE

FILL_TEST_DROITE				; ##########ALLER A DROITE
	INC DE:INC DE:INC DE: INC DE
		PUSH HL
	FILL_LIMITE_DROITE LD HL, 340
		OR A
		SBC HL, DE
   		POP HL
		JR C, FILL_LIMITE_DROITE_ATTEINT
	   PUSH HL
	   PUSH DE
	CALL #BBF0
	   POP DE
	   POP HL
	Fill_CoulDroit CP A, 00
	JR Z, FILL_TEST_DROITE 

	FILL_LIMITE_DROITE_ATTEINT
	DEC DE:DEC DE:DEC DE:DEC DE
	LD (FILL_ColDroite + 1), DE
    	POP DE					; Rappele le point de debut et aller a gauche
    	POP HL
    	PUSH HL
    	PUSH DE

FILL_TEST_GAUCHE				; ########## ALLER A GAUCHE
	DEC DE:DEC DE:DEC DE:DEC DE
		PUSH HL
	FILL_LIMITE_GAUCHE LD HL, 200
		OR A
		SBC HL, DE
		POP HL
		JR NC, FILL_LIMITE_GAUCHE_ATTEINT
   	PUSH HL
   	PUSH DE
	CALL #BBF0
   	POP DE
   	POP HL
	Fill_CoulGauche CP A, 00
	JR Z, FILL_TEST_GAUCHE

	FILL_LIMITE_GAUCHE_ATTEINT
	INC DE:INC DE:INC DE:INC DE
	LD (FILL_ColGauche + 1), DE
	CALL FILL_Remplir
   	POP DE
   	POP HL

FILL_TEST_HAUT
	NOP: NOP: NOP				; Sera remplace par un saut
	INC HL:INC HL
		PUSH HL
	FILL_LIMITE_HAUT LD BC, 200
		OR A
		SBC HL, BC
		POP HL
		JR NC, FILL_LIMITE_HAUT_ATTEINT 
   	PUSH HL
   	PUSH DE
	CALL #BBF0
   	POP DE
   	POP HL
	Fill_CoulHaut CP A, 00
	JR Z, FILL_DIR_HAUT

	FILL_LIMITE_HAUT_ATTEINT		; ########## DESCENDRE
	LD A, #DA 				; On place un saut pour ne pas refaire le haut (JP ....)
	LD (FILL_TEST_HAUT), A
	LD HL, FILL_TEST_BAS
	LD (FILL_TEST_HAUT + 1), HL
   	POP DE					; Rappeler les origines du depart
   	POP HL

FILL_TEST_BAS
	DEC HL
	DEC HL
	   	PUSH HL
	FILL_LIMITE_BAS LD BC, 80
		OR A
		SBC HL, BC
	   	POP HL
		JR C, FILL_LIMITE_BAS_ATTEINT
   	PUSH HL
   	PUSH DE
	CALL #BBF0
   	POP DE
   	POP HL
	Fill_CoulBas CP A, 00
	JP Z, FILL_DIR_HAUT

FILL_LIMITE_BAS_ATTEINT
	RET